[0m


XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



[1mNAME
     [0mxterm - terminal emulator for X

[1mSYNOPSIS
     xterm [0m[-_t_o_o_l_k_i_t_o_p_t_i_o_n ...] [-option ...]

[1mDESCRIPTION
     [0mThe _x_t_e_r_m program is a terminal emulator for the X Window
     System.  It provides DEC VT102 and Tektronix 4014 compatible
     terminals for programs that can't use the window system
     directly.	If the underlying operating system supports ter-
     minal resizing capabilities (for example, the SIGWINCH sig-
     nal in systems derived from 4.3bsd), _x_t_e_r_m will use the
     facilities to notify programs running in the window whenever
     it is resized.

     The VT102 and Tektronix 4014 terminals each have their own
     window so that you can edit text in one and look at graphics
     in the other at the same time.  To maintain the correct
     aspect ratio (height/width), Tektronix graphics will be res-
     tricted to the largest box with a 4014's aspect ratio that
     will fit in the window.  This box is located in the upper
     left area of the window.

     Although both windows may be displayed at the same time, one
     of them is considered the ``active'' window for receiving
     keyboard input and terminal output.  This is the window that
     contains the text cursor and whose border highlights when-
     ever the pointer is in either window.  The active window can
     be chosen through escape sequences, the ``Modes'' menu in
     the VT102 window, and the ``Tektronix'' menu in the 4014
     window.

[1mOPTIONS
     [0mThe _x_t_e_r_m terminal emulator accepts all of the standard X
     Toolkit command line options as well as the following (if
     the option begins with a `[1m+[0m' instead of a `[1m-[0m', the option is
     restored to its default value):

     [1m-help   [0mThis causes _x_t_e_r_m to print out a verbose message
	     describing its options.

     [1m-132    [0mNormally, the VT102 DECCOLM escape sequence that
	     switches between 80 and 132 column mode is ignored.
	     This option causes the DECCOLM escape sequence to be
	     recognized, and the _x_t_e_r_m window will resize
	     appropriately.

     [1m-ah     [0mThis option indicates that _x_t_e_r_m should always
	     highlight the text cursor and borders.  By default,
	     _x_t_e_r_m will display a hollow text cursor whenever the
	     focus is lost or the pointer leaves the window.



Printed 31/1/92             Release 4				1






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



     [1m+ah     [0mThis option indicates that _x_t_e_r_m should do text cur-
	     sor highlighting.

     [1m-b [0m_n_u_m_b_e_r
	     This option specifies the size of the inner border
	     (the distance between the outer edge of the charac-
	     ters and the window border) in pixels.  The default
	     is 2.

     [1m-cc [0m_c_h_a_r_a_c_t_e_r_c_l_a_s_s_r_a_n_g_e[1m:[0m_v_a_l_u_e[1m[,...]
	     [0mThis sets classes indicated by the given ranges for
	     using in selecting by words.  See the section speci-
	     fying character classes.

     [1m-cn     [0mThis option indicates that newlines should not be
	     cut in line-mode selections.

     [1m+cn     [0mThis option indicates that newlines should be cut in
	     line-mode selections.

     [1m-cr [0m_c_o_l_o_r
	     This option specifies the color to use for text cur-
	     sor.  The default is to use the same foreground
	     color that is used for text.

     [1m-cu     [0mThis option indicates that _x_t_e_r_m should work around
	     a bug in the _c_u_r_s_e_s(3x) cursor motion package that
	     causes the _m_o_r_e(1) program to display lines that are
	     exactly the width of the window and are followed by
	     a line beginning with a tab to be displayed
	     incorrectly (the leading tabs are not displayed).

     [1m+cu     [0mThis option indicates that that _x_t_e_r_m should not
	     work around the _c_u_r_s_e_s(3x) bug mentioned above.

     [1m-e [0m_p_r_o_g_r_a_m [_a_r_g_u_m_e_n_t_s ...]
	     This option specifies the program (and its command
	     line arguments) to be run in the _x_t_e_r_m window.  It
	     also sets the window title and icon name to be the
	     basename of the program being executed if neither -_T
	     nor -_n are given on the command line.  [1mThis must be
	     the last option on the command line.

     -fb [0m_f_o_n_t
	     This option specifies a font to be used when
	     displaying bold text. This font must be the same
	     height and width as the normal font.  If only one of
	     the normal or bold fonts is specified, it will be
	     used as the normal font and the bold font will be
	     produced by overstriking this font.  The default is
	     to do overstriking of the normal font.




Printed 31/1/92             Release 4				2






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



     [1m-j      [0mThis option indicates that _x_t_e_r_m should do jump
	     scrolling.  Normally, text is scrolled one line at a
	     time; this option allows _x_t_e_r_m to move multiple
	     lines at a time so that it doesn't fall as far
	     behind.  Its use is strongly recommended since it
	     make _x_t_e_r_m much faster when scanning through large
	     amounts of text.  The VT100 escape sequences for
	     enabling and disabling smooth scroll as well as the
	     ``Modes'' menu can be used to turn this feature on
	     or off.

     [1m+j      [0mThis option indicates that _x_t_e_r_m should not do jump
	     scrolling.

     [1m-l      [0mThis option indicates that _x_t_e_r_m should send all
	     terminal output to a log file as well as to the
	     screen.  This option can be enabled or disabled
	     using the ``xterm X11'' menu.

     [1m+l      [0mThis option indicates that _x_t_e_r_m should not do log-
	     ging.

     [1m-lf [0m_f_i_l_e_n_a_m_e
	     This option specifies the name of the file to which
	     the output log described above is written.  If _f_i_l_e
	     begins with a pipe symbol (|), the rest of the
	     string is assumed to be a command to be used as the
	     endpoint of a pipe.  The default filename is
	     ``[1mXtermLog.[0m_X_X_X_X_X'' (where _X_X_X_X_X is the process id of
	     _x_t_e_r_m) and is created in the directory from which
	     _x_t_e_r_m was started (or the user's home directory in
	     the case of a login window).

     [1m-ls     [0mThis option indicates that the shell that is started
	     in the _x_t_e_r_m window be a login shell (i.e. the first
	     character of argv[0] will be a dash, indicating to
	     the shell that it should read the user's .login or
	     .profile).

     [1m+ls     [0mThis option indicates that the shell that is started
	     should not be a login shell (i.e. it will be a nor-
	     mal ``subshell'').

     [1m-mb     [0mThis option indicates that _x_t_e_r_m should ring a mar-
	     gin bell when the user types near the right end of a
	     line.  This option can be turned on and off from the
	     ``Modes'' menu.

     [1m+mb     [0mThis option indicates that margin bell should not be
	     rung.

     [1m-mc milliseconds



[0mPrinted 31/1/92             Release 4				3






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



	     This option specifies the maximum time between
	     multi-click selections.

     [1m-ms [0m_c_o_l_o_r
	     This option specifies the color to be used for the
	     pointer cursor.  The default is to use the fore-
	     ground color.

     [1m-nb [0m_n_u_m_b_e_r
	     This option specifies the number of characters from
	     the right end of a line at which the margin bell, if
	     enabled, will ring.  The default is 10.

     [1m-rw     [0mThis option indicates that reverse-wraparound should
	     be allowed.  This allows the cursor to back up from
	     the leftmost column of one line to the rightmost
	     column of the previous line.  This is very useful
	     for editing long shell command lines and is
	     encouraged.  This option can be turned on and off
	     from the ``Modes'' menu.

     [1m+rw     [0mThis option indicates that reverse-wraparound should
	     not be allowed.

     [1m-s      [0mThis option indicates that _x_t_e_r_m may scroll asyn-
	     chronously, meaning that the screen does not have to
	     be kept completely up to date while scrolling.  This
	     allows _x_t_e_r_m to run faster when network latencies
	     are very high and is typically useful when running
	     across a very large internet or many gateways.

     [1m+s      [0mThis option indicates that _x_t_e_r_m should scroll syn-
	     chronously.

     [1m-sb     [0mThis option indicates that some number of lines that
	     are scrolled off the top of the window should be
	     saved and that a scrollbar should be displayed so
	     that those lines can be viewed.  This option may be
	     turned on and off from the ``Modes'' menu.

     [1m+sb     [0mThis option indicates that a scrollbar should not be
	     displayed.

     [1m-sf     [0mThis option indicates that Sun Function Key escape
	     codes should be generated for function keys.

     [1m+sf     [0mThis option indicates that the standard escape codes
	     should be generated for function keys.

     [1m-si     [0mThis option indicates that output to a window should
	     not automatically reposition the screen to the bot-
	     tom of the scrolling region. This option can be



Printed 31/1/92             Release 4				4






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



	     turned on and off from the ``Modes'' menu.

     [1m+si     [0mThis option indicates that output to a window should
	     cause it to scroll to the bottom.

     [1m-sk     [0mThis option indicates that pressing a key while
	     using the scrollbar to review previous lines of text
	     should cause the window to be repositioned automati-
	     cally in the normal position at the bottom of the
	     scroll region.

     [1m+sk     [0mThis option indicates that pressing a key while
	     using the scrollbar should not cause the window to
	     be repositioned.

     [1m-sl [0m_n_u_m_b_e_r
	     This option specifies the number of lines to save
	     that have been scrolled off the top of the screen.
	     The default is 64.

     [1m-t      [0mThis option indicates that _x_t_e_r_m should start in
	     Tektronix mode, rather than in VT102 mode.  Switch-
	     ing between the two windows is done using the
	     ``Modes'' menus.

     [1m+t      [0mThis option indicates that _x_t_e_r_m should start in
	     VT102 mode.

     [1m-tm [0m_s_t_r_i_n_g
	     This option specifies a series of terminal setting
	     keywords followed by the characters that should be
	     bound to those functions, similar to the _s_t_t_y pro-
	     gram.  Allowable keywords include: intr, quit,
	     erase, kill, eof, eol, swtch, start, stop, brk,
	     susp, dsusp, rprnt, flush, weras, and lnext.  Con-
	     trol characters may be specified as ^char (e.g. ^c
	     or ^u) and ^? may be used to indicate delete.

     [1m-tn [0m_n_a_m_e
	     This option specifies the name of the terminal type
	     to be set in the TERM environment variable.  This
	     terminal type must exist in the _t_e_r_m_c_a_p(_5) database
	     and should have _l_i# and _c_o# entries.

     [1m-ut     [0mThis option indicates that _x_t_e_r_m shouldn't write a
	     record into the the system log file /_e_t_c/_u_t_m_p.

     [1m+ut     [0mThis option indicates that _x_t_e_r_m should write a
	     record into the system log file /_e_t_c/_u_t_m_p.

     [1m-vb     [0mThis option indicates that a visual bell is pre-
	     ferred over an audible one.  Instead of ringing the



Printed 31/1/92             Release 4				5






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



	     terminal bell whenever a Control-G is received, the
	     window will be flashed.

     [1m+vb     [0mThis option indicates that a visual bell should not
	     be used.

     [1m-wf     [0mThis option indicates that _x_t_e_r_m should wait for the
	     window to be mapped the first time before starting
	     the subprocess so that the initial terminal size
	     settings and environment variables are correct.  It
	     the application's responsibility to catch subsequent
	     terminal size changes.

     [1m+wf     [0mThis option indicates that _x_t_e_r_m show not wait
	     before starting the subprocess.

     [1m-C      [0mThis option indicates that this window should
	     receive console output.  This is not supported on
	     all systems.

     [1m-S[0m_c_c_n   This option specifies the last two letters of the
	     name of a pseudoterminal to use in slave mode, plus
	     the number of the inherited file descriptor.  The
	     option is parsed "%c%c%d".  This allows _x_t_e_r_m to be
	     used as an input and output channel for an existing
	     program and is sometimes used in specialized appli-
	     cations.

     The following command line arguments are provided for compa-
     tibility with older versions.  They may not be supported in
     the next release as the X Toolkit provides standard options
     that accomplish the same task.

     [1m%[0m_g_e_o_m   This option specifies the preferred size and posi-
	     tion of the Tektronix window.  It is shorthand for
	     specifying the "*_t_e_k_G_e_o_m_e_t_r_y" resource.

     [1m#[0m_g_e_o_m   This option specifies the preferred position of the
	     icon window.  It is shorthand for specifying the
	     "*_i_c_o_n_G_e_o_m_e_t_r_y" resource.

     [1m-T [0m_s_t_r_i_n_g
	     This option specifies the title for _x_t_e_r_m's windows.
	     It is equivalent to [1m-title[0m.

     [1m-n [0m_s_t_r_i_n_g
	     This option specifies the icon name for _x_t_e_r_m's win-
	     dows.  It is shorthand for specifying the "*_i_c_o_n_-
	     _N_a_m_e" resource.  Note that this is not the same as
	     the toolkit option [1m-name [0m(see below).  The default
	     icon name is the application name.




Printed 31/1/92             Release 4				6






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



     [1m-r      [0mThis option indicates that reverse video should be
	     simulated by swapping the foreground and background
	     colors.  It is equivalent to [1m-reversevideo [0mor [1m-rv[0m.

     [1m-w [0m_n_u_m_b_e_r
	     This option specifies the width in pixels of the
	     border surrounding the window.  It is equivalent to
	     [1m-borderwidth [0mor [1m-bw[0m.

     The following standard X Toolkit command line arguments are
     commonly used with _x_t_e_r_m:

     [1m-bg [0m_c_o_l_o_r
	     This option specifies the color to use for the back-
	     ground of the window. The default is ``white.''

     [1m-bd [0m_c_o_l_o_r
	     This option specifies the color to use for the
	     border of the window.  The default is ``black.''

     [1m-bw [0m_n_u_m_b_e_r
	     This option specifies the width in pixels of the
	     border surrounding the window.

     [1m-fg [0m_c_o_l_o_r
	     This option specifies the color to use for display-
	     ing text.	The default is ``black''.

     [1m-fn [0m_f_o_n_t
	     This option specifies the font to be used for
	     displaying normal text.  The default is _f_i_x_e_d.

     [1m-name [0m_n_a_m_e
	     This option specifies the application name under
	     which resources are to be obtained, rather than the
	     default executable file name.  _N_a_m_e should not con-
	     tain ``.'' or ``*'' characters.

     [1m-title [0m_s_t_r_i_n_g
	     This option specifies the window title string, which
	     may be displayed by window managers if the user so
	     chooses.  The default title is the command line
	     specified after the [1m-e [0moption, if any, otherwise the
	     application name.

     [1m-rv     [0mThis option indicates that reverse video should be
	     simulated by swapping the foreground and background
	     colors.

     [1m-geometry [0m_g_e_o_m_e_t_r_y
	     This option specifies the preferred size and posi-
	     tion of the VT102 window; see _X(_1).



Printed 31/1/92             Release 4				7






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



     [1m-display [0m_d_i_s_p_l_a_y
	     This option specifies the X server to contact; see
	     _X(_1).

     [1m-xrm [0m_r_e_s_o_u_r_c_e_s_t_r_i_n_g
	     This option specifies a resource string to be used.
	     This is especially useful for setting resources that
	     do not have separate command line options.

     [1m-iconic [0mThis option indicates that _x_t_e_r_m should ask the win-
	     dow manager to start it as an icon rather than as
	     the normal window.

[1mRESOURCES
     [0mThe program understands all of the core X Toolkit resource
     names and classes as well as:

     [1miconGeometry ([0mclass [1mIconGeometry)
	     [0mSpecifies the preferred size and position of the
	     application when iconified.  It is not necessarily
	     obeyed by all window managers.

     [1mtermName ([0mclass [1mTermName)
	     [0mSpecifies the terminal type name to be set in the
	     TERM environment variable.

     [1mtitle ([0mclass [1mTitle)
	     [0mSpecifies a string that may be used by the window
	     manager when displaying this application.

     [1mttyModes ([0mclass [1mTtyModes)
	     [0mSpecifies a string containing terminal setting key-
	     words and the characters to which they may be bound.
	     Allowable keywords include: intr, quit, erase, kill,
	     eof, eol, swtch, start, stop, brk, susp, dsusp,
	     rprnt, flush, weras, and lnext.  Control characters
	     may be specified as ^char (e.g. ^c or ^u) and ^? may
	     be used to indicate delete.  This is very useful for
	     overriding the default terminal settings without
	     having to do an _s_t_t_y every time an _x_t_e_r_m is started.

     [1mutmpInhibit ([0mclass [1mUtmpInhibit)
	     [0mSpecifies whether or not _x_t_e_r_m should try to record
	     the user's terminal in /_e_t_c/_u_t_m_p.

     [1msunFunctionKeys ([0mclass [1mSunFunctionKeys)
	     [0mSpecifies whether or not Sun Function Key escape
	     codes should be generated for function keys instead
	     of standard escape sequences.






Printed 31/1/92             Release 4				8






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



     The following resources are specified as part of the _v_t_1_0_0
     widget (class _V_T_1_0_0):

     [1mallowSendEvents ([0mclass [1mAllowSendEvents)
	     [0mSpecifies whether or not synthetic key and button
	     events (generated using the X protocol SendEvent
	     request) should be interpreted or discarded.  The
	     default is ``false'' meaning they are discarded.
	     Note that allowing such events creates a very large
	     security hole.


     [1malwaysHighlight ([0mclass [1mAlwaysHighlight)
	     [0mSpecifies whether or not _x_t_e_r_m should always display
	     a highlighted text cursor.  By default, a hollow
	     text cursor is displayed whenever the pointer moves
	     out of the window or the window loses the input
	     focus.

     [1mboldFont ([0mclass [1mFont)
	     [0mSpecifies the name of the bold font to use instead
	     of overstriking.

     [1mc132 ([0mclass [1mC132)
	     [0mSpecifies whether or not the VT102 DECCOLM escape
	     sequence should be honored.  The default is
	     ``false.''

     [1mcharClass ([0mclass [1mCharClass)
	     [0mSpecifies comma-separated lists of character class
	     bindings of the form [_l_o_w-]_h_i_g_h:_v_a_l_u_e.  These are
	     used in determining which sets of characters should
	     be treated the same when doing cut and paste.  See
	     the section on specifying character classes.

     [1mcurses ([0mclass [1mCurses)
	     [0mSpecifies whether or not the last column bug in
	     _c_u_r_s_e_s(3x) should be worked around.  The default is
	     ``false.''

     [1mbackground ([0mclass [1mBackground)
	     [0mSpecifies the color to use for the background of the
	     window.  The default is ``white.''

     [1mforeground ([0mclass [1mForeground)
	     [0mSpecifies the color to use for displaying text in
	     the window.  Setting the class name instead of the
	     instance name is an easy way to have everything that
	     would normally appear in the "text" color change
	     color.  The default is ``black.''

     [1mcursorColor ([0mclass [1mForeground)



[0mPrinted 31/1/92             Release 4				9






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



	     Specifies the color to use for the text cursor.  The
	     default is ``black.''

     [1meightBitInput ([0mclass [1mEightBitInput[0m)
	     Specifies whether or not eight-bit characters should
	     be accepted.  The default is ``true.''

     [1mfont ([0mclass [1mFont)
	     [0mSpecifies the name of the normal font.  The default
	     is ``vtsingle.''

     [1mfont1 ([0mclass [1mFont1)
	     [0mSpecifies the name of the first alternate font.

     [1mfont2 ([0mclass [1mFont2)
	     [0mSpecifies the name of the second alternate font.

     [1mfont3 ([0mclass [1mFont3)
	     [0mSpecifies the name of the third alternate font.

     [1mfont4 ([0mclass [1mFont4)
	     [0mSpecifies the name of the fourth alternate font.

     [1mgeometry ([0mclass [1mGeometry)
	     [0mSpecifies the preferred size and position of the
	     VT102 window.

     [1minternalBorder ([0mclass [1mBorderWidth)
	     [0mSpecifies the number of pixels between the charac-
	     ters and the window border.  The default is 2.

     [1mjumpScroll ([0mclass [1mJumpScroll)
	     [0mSpecifies whether or not jump scroll should be used.
	     The default is ``true''.

     [1mlogFile ([0mclass [1mLogfile)
	     [0mSpecifies the name of the file to which a terminal
	     session is logged.  The default is
	     ``[1mXtermLog.[0m_X_X_X_X_X'' (where _X_X_X_X_X is the process id of
	     _x_t_e_r_m).

     [1mlogging ([0mclass [1mLogging)
	     [0mSpecifies whether or not a terminal session should
	     be logged.  The default is ``false.''

     [1mlogInhibit ([0mclass [1mLogInhibit)
	     [0mSpecifies whether or not terminal session logging
	     should be inhibited.  The default is ``false.''

     [1mloginShell ([0mclass [1mLoginShell)
	     [0mSpecifies whether or not the shell to be run in the
	     window should be started as a login shell.  The



Printed 31/1/92             Release 4			       10






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



	     default is ``false.''

     [1mmarginBell ([0mclass [1mMarginBell)
	     [0mSpecifies whether or not the bell should be run when
	     the user types near the right margin.  The default
	     is ``false.''

     [1mmultiClickTime ([0mclass [1mMultiClickTime)
	     [0mSpecifies the maximum time in milliseconds between
	     multi-clock select events.  The default is 250 mil-
	     liseconds.

     [1mmultiScroll ([0mclass [1mMultiScroll)
	     [0mSpecifies whether or not scrolling should be done
	     asynchronously.  The default is ``false.''

     [1mnMarginBell ([0mclass [1mColumn)
	     [0mSpecifies the number of characters from the right
	     margin at which the margin bell should be run, when
	     enabled.

     [1mpointerColor ([0mclass [1mForeground)
	     [0mSpecifies the foreground color of the pointer.  The
	     default is ``XtDefaultForeground.''

     [1mpointerColorBackground ([0mclass [1mBackground)
	     [0mSpecifies the background color of the pointer.  The
	     default is ``XtDefaultBackground.''

     [1mpointerShape ([0mclass [1mCursor)
	     [0mSpecifies the name of the shape of the pointer.  The
	     default is ``xterm.''

     [1mreverseVideo ([0mclass [1mReverseVideo)
	     [0mSpecifies whether or not reverse video should be
	     simulated.  The default is ``false.''

     [1mreverseWrap ([0mclass [1mReverseWrap)
	     [0mSpecifies whether or not reverse-wraparound should
	     be enabled.  The default is ``false.''

     [1msaveLines ([0mclass [1mSaveLines)
	     [0mSpecifies the number of lines to save beyond the top
	     of the screen when a scrollbar is turned on.  The
	     default is 64.

     [1mscrollBar ([0mclass [1mScrollBar)
	     [0mSpecifies whether or not the scrollbar should be
	     displayed.  The default is ``false.''

     [1mscrollInput ([0mclass [1mScrollCond)
	     [0mSpecifies whether or not output to the terminal



Printed 31/1/92             Release 4			       11






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



	     should automatically cause the scrollbar to go to
	     the bottom of the scrolling region.  The default is
	     ``true.''

     [1mscrollKey ([0mclass [1mScrollCond)
	     [0mSpecifies whether or not pressing a key should
	     automatically cause the scrollbar to go to the bot-
	     tom of the scrolling region.  The default is
	     ``false.''

     [1mscrollLines ([0mclass [1mScrollLines)
	     [0mSpecifies the number of lines that the _s_c_r_o_l_l-_b_a_c_k
	     and _s_c_r_o_l_l-_f_o_r_w actions should use as a default.
	     The default value is 1.

     [1msignalInhibit ([0mclass [1mSignalInhibit)
	     [0mSpecifies whether or not the entries in the ``xterm
	     X11'' menu for sending signals to _x_t_e_r_m should be
	     disallowed.  The default is ``false.''

     [1mtekGeometry ([0mclass [1mGeometry)
	     [0mSpecifies the preferred size and position of the
	     Tektronix window.

     [1mtekInhibit ([0mclass [1mTekInhibit)
	     [0mSpecifies whether or not Tektronix mode should be
	     disallowed.  The default is ``false.''

     [1mtekSmall ([0mclass [1mTekSmall)
	     [0mSpecifies whether or not the Tektronix mode window
	     should start in its smallest size if no explicit
	     geometry is given.  This is useful when running
	     _x_t_e_r_m on displays with small screens.  The default
	     is ``false.''

     [1mtekStartup ([0mclass [1mTekStartup)
	     [0mSpecifies whether or not _x_t_e_r_m should start up in
	     Tektronix mode.  The default is ``false.''

     [1mtiteInhibit ([0mclass [1mTiteInhibit)
	     [0mSpecifies whether or not _x_t_e_r_m should remove remove
	     _t_i or _t_e termcap entries (used to switch between
	     alternate screens on startup of many screen-oriented
	     programs) from the TERMCAP string.

     [1mtranslations ([0mclass [1mTranslations)
	     [0mSpecifies the key and button bindings for menus,
	     selections, ``programmed strings'', etc.  See
	     [1mACTIONS [0mbelow.

     [1mvisualBell ([0mclass [1mVisualBell)
	     [0mSpecifies whether or not a visible bell (i.e.



Printed 31/1/92             Release 4			       12






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



	     flashing) should be used instead of an audible bell
	     when Control-G is received.  The default is
	     ``false.''

     [1mwaitForMap ([0mclass [1mWaitForMap)
	     [0mSpecifies whether or not _x_t_e_r_m should wait for the
	     initial window map before starting the subprocess.
	     The default is ``false.''


     The following resources are specified as part of the _t_e_k_4_0_1_4
     widget (class _T_e_k_4_0_1_4):

     [1mwidth ([0mclass [1mWidth)
	     [0mSpecifies the width of the Tektronix window in pix-
	     els.

     [1mheight ([0mclass [1mHeight)
	     [0mSpecifies the height of the Tektronix window in pix-
	     els.

     [1mfontLarge ([0mclass [1mFont)
	     [0mSpecifies the large font to use in the Tektronix
	     window.

     [1mfont2 ([0mclass [1mFont)
	     [0mSpecifies font number 2 to use in the Tektronix win-
	     dow.

     [1mfont3 ([0mclass [1mFont)
	     [0mSpecifies font number 2 font to use in the Tektronix
	     window.

     [1mfontSmall ([0mclass [1mFont)
	     [0mSpecifies the small font to use in the Tektronix
	     window.


     The resources that may be specified for the various menus
     are described in the documentation for the Athena [1mSimpleMenu
     [0mwidget.  The name and classes of the entries in each of the
     menus are listed below.

     The _m_a_i_n_M_e_n_u has the following entries:

     [1msecurekbd ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1msecure() [0maction.

     [1mallowsends ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mallow-send-events(toggle)
	     [0maction.




Printed 31/1/92             Release 4			       13






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



     [1mlogging ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-logging(toggle) [0maction.

     [1mredraw ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mredraw() [0maction.

     [1mline1 ([0mclass [1mSmeLine)
	     [0mThis is a separator.

     [1msuspend ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1msend-signal(suspend) [0maction
	     on systems that support job control.

     [1mcontinue ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1msend-signal(cont) [0maction on
	     systems that support job control.

     [1minterrupt ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1msend-signal(int) [0maction.

     [1mhangup ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1msend-signal(hup) [0maction.

     [1mterminate ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1msend-signal(term) [0maction.

     [1mkill ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1msend-signal(kill) [0maction.

     [1mline2 ([0mclass [1mSmeLine)
	     [0mThis is a separator.

     [1mquit ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mquit() [0maction.


     The _v_t_M_e_n_u has the following entries:

     [1mscrollbar ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-scrollbar(toggle) [0maction.

     [1mjumpscroll ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-jumpscroll(toggle)
	     [0maction.

     [1mreversevideo ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-reverse-video(toggle)
	     [0maction.

     [1mautowrap ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-autowrap(toggle) [0maction.




Printed 31/1/92             Release 4			       14






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



     [1mreversewrap ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-reversewrap(toggle)
	     [0maction.

     [1mautolinefeed ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-autolinefeed(toggle)
	     [0maction.

     [1mappcursor ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-appcursor(toggle) [0maction.

     [1mappkeypad ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-appkeypad(toggle) [0maction.

     [1mscrollkey ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-scroll-on-key(toggle)
	     [0maction.

     [1mscrollttyoutput ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-scroll-on-tty-
	     output(toggle) [0maction.

     [1mallow132 ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-allow132(toggle) [0maction.

     [1mcursesemul ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-cursesemul(toggle)
	     [0maction.

     [1mvisualbell ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-visualbell(toggle)
	     [0maction.

     [1mmarginbell ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-marginbell(toggle)
	     [0maction.

     [1maltscreen ([0mclass [1mSmeBSB)
	     [0mThis entry is currently disabled.

     [1mline1 ([0mclass [1mSmeLine)
	     [0mThis is a separator.

     [1msoftreset ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1msoft-reset() [0maction.

     [1mhardreset ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mhard-reset() [0maction.

     [1mline2 ([0mclass [1mSmeLine)
	     [0mThis is a separator.




Printed 31/1/92             Release 4			       15






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



     [1mtekshow ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-visibility(tek,toggle)
	     [0maction.

     [1mtekmode ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-terminal-type(tek)
	     [0maction.

     [1mvthide ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-visibility(vt,off)
	     [0maction.


     The _f_o_n_t_M_e_n_u has the following entries:

     [1mfontdefault ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-vt-font(d) [0maction.

     [1mfont1 ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-vt-font(1) [0maction.

     [1mfont2 ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-vt-font(2) [0maction.

     [1mfont3 ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-vt-font(3) [0maction.

     [1mfont4 ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-vt-font(4) [0maction.

     [1mfontescape ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-vt-font(e) [0maction.

     [1mfontsel ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-vt-font(s) [0maction.


     The _t_e_k_M_e_n_u has the following entries:

     [1mtektextlarge ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-tek-text(l) [0maction.

     [1mtektext2 ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-tek-text(2) [0maction.

     [1mtektext3 ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-tek-text(3) [0maction.

     [1mtektextsmall ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-tek-text(s) [0maction.

     [1mline1 ([0mclass [1mSmeLine)



[0mPrinted 31/1/92             Release 4			       16






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



	     This is a separator.

     [1mtekpage ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mtek-page() [0maction.

     [1mtekreset ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mtek-reset() [0maction.

     [1mtekcopy ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mtek-copy() [0maction.

     [1mline2 ([0mclass [1mSmeLine)
	     [0mThis is a separator.

     [1mvtshow ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-visibility(vt,toggle)
	     [0maction.

     [1mvtmode ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-terminal-type(vt) [0maction.

     [1mtekhide ([0mclass [1mSmeBSB)
	     [0mThis entry invokes the [1mset-visibility(tek,toggle)
	     [0maction.


     The following resources are useful when specified for the
     Athena Scrollbar widget:

     [1mthickness ([0mclass [1mThickness)
	     [0mSpecifies the width in pixels of the scrollbar.

     [1mbackground ([0mclass [1mBackground)
	     [0mSpecifies the color to use for the background of the
	     scrollbar.

     [1mforeground ([0mclass [1mForeground)
	     [0mSpecifies the color to use for the foreground of the
	     scrollbar.  The ``thumb'' of the scrollbar is a sim-
	     ple checkerboard pattern alternating pixels for
	     foreground and background color.

[1mEMULATIONS
     [0mThe VT102 emulation is fairly complete, but does not support
     the blinking character attribute nor the double-wide and
     double-size character sets.  _T_e_r_m_c_a_p(5) entries that work
     with _x_t_e_r_m include ``xterm'', ``vt102'', ``vt100'' and
     ``ansi'', and _x_t_e_r_m automatically searches the termcap file
     in this order for these entries and then sets the ``TERM''
     and the ``TERMCAP'' environment variables.





Printed 31/1/92             Release 4			       17






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



     Many of the special _x_t_e_r_m features (like logging) may be
     modified under program control through a set of escape
     sequences different from the standard VT102 escape
     sequences. (See the ``_X_t_e_r_m _C_o_n_t_r_o_l _S_e_q_u_e_n_c_e_s'' document.)

     The Tektronix 4014 emulation is also fairly good.	Four dif-
     ferent font sizes and five different lines types are sup-
     ported.  The Tektronix text and graphics commands are
     recorded internally by _x_t_e_r_m and may be written to a file by
     sending the COPY escape sequence (or through the [1mTektronix
     [0mmenu; see below).	The name of the file will be
     ``[1mCOPY[0m_y_y[1m-[0m_M_M[1m-[0m_d_d[1m.[0m_h_h[1m:[0m_m_m[1m:[0m_s_s'', where _y_y, _M_M, _d_d, _h_h, _m_m and _s_s
     are the year, month, day, hour, minute and second when the
     COPY was performed (the file is created in the directory
     _x_t_e_r_m is started in, or the home directory for a login
     _x_t_e_r_m).

[1mPOINTER USAGE
     [0mOnce the VT102 window is created, _x_t_e_r_m allows you to select
     text and copy it within the same or other windows.

     The selection functions are invoked when the pointer buttons
     are used with no modifiers, and when they are used with the
     ``shift'' key.  The assignment of the functions described
     below to keys and buttons may be changed through the
     resource database; see [1mACTIONS [0mbelow.

     Pointer button one (usually left) is used to save text into
     the cut buffer.  Move the cursor to beginning of the text,
     and then hold the button down while moving the cursor to the
     end of the region and releasing the button.  The selected
     text is highlighted and is saved in the global cut buffer
     and made the PRIMARY selection when the button is released.
     Double-clicking selects by words.	Triple-clicking selects
     by lines.	Quadruple-clicking goes back to characters, etc.
     Multiple-click is determined by the time from button up to
     button down, so you can change the selection unit in the
     middle of a selection.  If the key/button bindings specify
     that an X selection is to be made, _x_t_e_r_m will leave the
     selected text highlighted for as long as it is the selection
     owner.

     Pointer button two (usually middle) `types' (pastes) the
     text from the PRIMARY selection, if any, otherwise from the
     cut buffer, inserting it as keyboard input.

     Pointer button three (usually right) extends the current
     selection.  (Without loss of generality, that is you can
     swap ``right'' and ``left'' everywhere in the rest of this
     paragraph...)  If pressed while closer to the right edge of
     the selection than the left, it extends/contracts the right
     edge of the selection.  If you contract the selection past



Printed 31/1/92             Release 4			       18






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



     the left edge of the selection, _x_t_e_r_m assumes you really
     meant the left edge, restores the original selection, then
     extends/contracts the left edge of the selection.	Extension
     starts in the selection unit mode that the last selection or
     extension was performed in; you can multiple-click to cycle
     through them.

     By cutting and pasting pieces of text without trailing new
     lines, you can take text from several places in different
     windows and form a command to the shell, for example, or
     take output from a program and insert it into your favorite
     editor.  Since the cut buffer is globally shared among dif-
     ferent applications, you should regard it as a `file' whose
     contents you know.  The terminal emulator and other text
     programs should be treating it as if it were a text file,
     i.e. the text is delimited by new lines.

     The scroll region displays the position and amount of text
     currently showing in the window (highlighted) relative to
     the amount of text actually saved.  As more text is saved
     (up to the maximum), the size of the highlighted area
     decreases.

     Clicking button one with the pointer in the scroll region
     moves the adjacent line to the top of the display window.

     Clicking button three moves the top line of the display win-
     dow down to the pointer position.

     Clicking button two moves the display to a position in the
     saved text that corresponds to the pointer's position in the
     scrollbar.

     Unlike the VT102 window, the Tektronix window dows not allow
     the copying of text.  It does allow Tektronix GIN mode, and
     in this mode the cursor will change from an arrow to a
     cross.  Pressing any key will send that key and the current
     coordinate of the cross cursor.  Pressing button one, two,
     or three will return the letters `l', `m', and `r', respec-
     tively.  If the `shift' key is pressed when a pointer button
     is pressed, the corresponding upper case letter is sent.  To
     distinguish a pointer button from a key, the high bit of the
     character is set (but this is bit is normally stripped
     unless the terminal mode is RAW; see _t_t_y(4) for details).

[1mMENUS
     [0m_X_t_e_r_m has four menus, named _m_a_i_n_M_e_n_u, _v_t_M_e_n_u, _f_o_n_t_M_e_n_u, and
     _t_e_k_M_e_n_u.  Each menu pops up under the correct combinations
     of key and button presses.  Most menus are divided into two
     section, separated by a horizontal line.  The top portion
     contains various modes that can be altered.  A check mark
     appears next to a mode that is currently active.  Selecting



Printed 31/1/92             Release 4			       19






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



     one of these modes toggles its state.  The bottom portion of
     the menu are command entries; selecting one of these per-
     forms the indicated function.

     The [1mxterm [0mmenu pops up when the ``control'' key and pointer
     button one are pressed in a window.  The _m_a_i_n_M_e_n_u contains
     items that apply to both the VT102 and Tektronix windows.
     The [1mSecure Keyboard [0mmode is be used when typing in passwords
     or other sensitive data in an unsecure environment; see
     [1mSECURITY [0mbelow.  Notable entries in the command section of
     the menu are the [1mContinue[0m, [1mSuspend[0m, [1mInterrupt[0m, [1mHangup[0m, [1mTer-
     minate [0mand [1mKill [0mwhich sends the SIGCONT, SIGTSTP, SIGINT,
     SIGHUP, SIGTERM and SIGKILL signals, respectively, to the
     process group of the process running under _x_t_e_r_m (usually
     the shell).  The [1mContinue [0mfunction is especially useful if
     the user has accidentally typed CTRL-Z, suspending the pro-
     cess.

     The _v_t_M_e_n_u sets various modes in the VT102 emulation, and is
     popped up when the ``control'' key and pointer button two
     are pressed in the VT102 window.  In the command section of
     this menu, the soft reset entry will reset scroll regions.
     This can be convenient when some program has left the scroll
     regions set incorrectly (often a problem when using VMS or
     TOPS-20).	The full reset entry will clear the screen, reset
     tabs to every eight columns, and reset the terminal modes
     (such as wrap and smooth scroll) to their initial states
     just after _x_t_e_r_m has finished processing the command line
     options.

     The _f_o_n_t_M_e_n_u sets the font used in the VT102 window.

     The _t_e_k_M_e_n_u sets various modes in the Tektronix emulation,
     and is popped up when the ``control'' key and pointer button
     two are pressed in the Tektronix window.  The current font
     size is checked in the modes section of the menu.	The [1mPAGE
     [0mentry in the command section clears the Tektronix window.

[1mSECURITY
     [0mX environments differ in their security consciousness.  MIT
     servers, run under _x_d_m, are capable of using a ``magic
     cookie'' authorization scheme that can provide a reasonable
     level of security for many people.  If your server is only
     using a host-based mechanism to control access to the server
     (see _x_h_o_s_t(_1)), then if you enable access for a host and
     other users are also permitted to run clients on that same
     host, there is every possibility that someone can run an
     application that will use the basic services of the X proto-
     col to snoop on your activities, potentially capturing a
     transcript of everything you type at the keyboard.  This is
     of particular concern when you want to type in a password or
     other sensitive data.  The best solution to this problem is



Printed 31/1/92             Release 4			       20






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



     to use a better authorization mechanism that host-based con-
     trol, but a simple mechanism exists for protecting keyboard
     input in _x_t_e_r_m.

     The [1mxterm [0mmenu (see [1mMENUS [0mabove) contains a [1mSecure Keyboard
     [0mentry which, when enabled, ensures that all keyboard input
     is directed _o_n_l_y to _x_t_e_r_m (using the GrabKeyboard protocol
     request).	When an application prompts you for a password
     (or other sensitive data), you can enable [1mSecure Keyboard
     [0musing the menu, type in the data, and then disable [1mSecure
     Keyboard [0musing the menu again.  Only one X client at a time
     can secure the keyboard, so when you attempt to enable
     [1mSecure Keyboard [0mit may fail.  In this case, the bell will
     sound.  If the [1mSecure Keyboard [0msucceeds, the foreground and
     background colors will be exchanged (as if you selected the
     [1mReverse Video [0mentry in the [1mModes [0mmenu); they will be
     exchanged again when you exit secure mode.  If the colors do
     _n_o_t switch, then you should be _v_e_r_y suspicious that you are
     being spoofed.  If the application you are running displays
     a prompt before asking for the password, it is safest to
     enter secure mode _b_e_f_o_r_e the prompt gets displayed, and to
     make sure that the prompt gets displayed correctly (in the
     new colors), to minimize the probability of spoofing.  You
     can also bring up the menu again and make sure that a check
     mark appears next to the entry.

     [1mSecure Keyboard [0mmode will be disabled automatically if your
     xterm window becomes iconified (or otherwise unmapped), or
     if you start up a reparenting window manager (that places a
     title bar or other decoration around the window) while in
     [1mSecure Keyboard [0mmode.  (This is a feature of the X protocol
     not easily overcome.)  When this happens, the foreground and
     background colors will be switched back and the bell will
     sound in warning.

[1mCHARACTER CLASSES
     [0mClicking pointer button 1 twice in rapid succession will
     cause all characters of the same class (e.g. letters, white
     space, punctuation) to be selected.  Since different people
     have different preferences for what should be selected (for
     example, should filenames be selected as a whole or only the
     separate subnames), the default mapping can be overridden
     through the use of the _c_h_a_r_C_l_a_s_s (class _C_h_a_r_C_l_a_s_s) resource.

     This resource is simply a list of _r_a_n_g_e:_v_a_l_u_e pairs where
     the range is either a single number or _l_o_w-_h_i_g_h in the range
     of 0 to 127, corresponding to the ASCII code for the charac-
     ter or characters to be set.  The _v_a_l_u_e is arbitrary,
     although the default table uses the character number of the
     first character occurring in the set.





Printed 31/1/92             Release 4			       21






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



     The default table is:

	       static int charClass[128] = {
	       /* NUL  SOH  STX  ETX  EOT  ENQ	ACK  BEL */
		   32,	 1,   1,   1,	1,   1,   1,   1,
	       /*  BS	HT   NL   VT   NP   CR	 SO   SI */
		    1,	32,   1,   1,	1,   1,   1,   1,
	       /* DLE  DC1  DC2  DC3  DC4  NAK	SYN  ETB */
		    1,	 1,   1,   1,	1,   1,   1,   1,
	       /* CAN	EM  SUB  ESC   FS   GS	 RS   US */
		    1,	 1,   1,   1,	1,   1,   1,   1,
	       /*  SP	 !    "    #	$    %	  &    ' */
		   32,	33,  34,  35,  36,  37,  38,  39,
	       /*   (	 )    *    +	,    -	  .    / */
		   40,	41,  42,  43,  44,  45,  46,  47,
	       /*   0	 1    2    3	4    5	  6    7 */
		   48,	48,  48,  48,  48,  48,  48,  48,
	       /*   8	 9    :    ;	<    =	  >    ? */
		   48,	48,  58,  59,  60,  61,  62,  63,
	       /*   @	 A    B    C	D    E	  F    G */
		   64,	48,  48,  48,  48,  48,  48,  48,
	       /*   H	 I    J    K	L    M	  N    O */
		   48,	48,  48,  48,  48,  48,  48,  48,
	       /*   P	 Q    R    S	T    U	  V    W */
		   48,	48,  48,  48,  48,  48,  48,  48,
	       /*   X	 Y    Z    [	\    ]	  ^    _ */
		   48,	48,  48,  91,  92,  93,  94,  48,
	       /*   `	 a    b    c	d    e	  f    g */
		   96,	48,  48,  48,  48,  48,  48,  48,
	       /*   h	 i    j    k	l    m	  n    o */
		   48,	48,  48,  48,  48,  48,  48,  48,
	       /*   p	 q    r    s	t    u	  v    w */
		   48,	48,  48,  48,  48,  48,  48,  48,
	       /*   x	 y    z    {	|    }	  ~  DEL */
		   48,	48,  48, 123, 124, 125, 126,   1};

     For example, the string ``33:48,37:48,45-47:48,64:48'' indi-
     cates that the exclamation mark, percent sign, dash, period,
     slash, and ampersand characters should be treated the same
     way as characters and numbers.  This is very useful for cut-
     ting and pasting electronic mailing addresses and filenames.

[1mACTIONS
     [0mIt is possible to rebind keys (or sequences of keys) to
     arbitrary strings for input, by changing the translations
     for the vt100 or tek4014 widgets.	Changing the translations
     for events other than key and button events is not expected,
     and will cause unpredictable behavior.  The following
     actions are provided for using within the _v_t_1_0_0 or _t_e_k_4_0_1_4
     [1mtranslations [0mresources:

     [1mbell([[0m_p_e_r_c_e_n_t[1m])



[0mPrinted 31/1/92             Release 4			       22






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



	     This action rings the keyboard bell at the specified
	     percentage above or below the base volume.

     [1mignore()
	     [0mThis action ignores the event but checks for special
	     pointer position escape sequences.

     [1minsert()
	     [0mThis action is a synonym for [1minsert-seven-bit()

     insert-seven-bit()
	     [0mThis action inserts the 7-bit USASCII character or
	     string associated with the keysym that was pressed.

     [1minsert-eight-bit()
	     [0mThis action inserts the 8-bit ISO Latin-1 character
	     or string associated with the keysym that was
	     pressed.

     [1minsert-selection([0m_s_o_u_r_c_e_n_a_m_e [1m[, ...])
	     [0mThis action inserts the string found in the selec-
	     tion or cutbuffer indicated by _s_o_u_r_c_e_n_a_m_e.  Sources
	     are checked in the order given (case is significant)
	     until one is found.  Commonly-used selections
	     include: _P_R_I_M_A_R_Y, _S_E_C_O_N_D_A_R_Y, and _C_L_I_P_B_O_A_R_D.  Cut
	     buffers are typically named _C_U_T__B_U_F_F_E_R_0 through
	     _C_U_T__B_U_F_F_E_R_7.

     [1mkeymap([0m_n_a_m_e[1m)
	     [0mThis action dynamically defines a new translation
	     table whose resource name is _n_a_m_e with the suffix
	     _K_e_y_m_a_p (case is significant).  The name _N_o_n_e
	     restores the original translation table.

     [1mpopup-menu([0m_m_e_n_u_n_a_m_e[1m)
	     [0mThis action displays the specified popup menu.
	     Valid names (case is significant) include:  _m_a_i_n_-
	     _M_e_n_u, _v_t_M_e_n_u, _f_o_n_t_M_e_n_u, and _t_e_k_M_e_n_u.

     [1msecure()
	     [0mThis action toggles the _S_e_c_u_r_e _K_e_y_b_o_a_r_d mode
	     described in the section named [1mSECURITY[0m, and is
	     invoked from the [1msecurekbd [0mentry in _m_a_i_n_M_e_n_u.

     [1mselect-start()
	     [0mThis action begins text selection at the current
	     pointer location.	See the section on [1mPOINTER USAGE
	     [0mfor information on making selections.

     [1mselect-extend()
	     [0mThis action tracks the pointer and extends the
	     selection.  It should only be bound to Motion



Printed 31/1/92             Release 4			       23






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



	     events.

     [1mselect-end([0m_d_e_s_t_n_a_m_e [1m[, ...])
	     [0mThis action puts the currently selected text into
	     all of the selections or cutbuffers specified by
	     _d_e_s_t_n_a_m_e.

     [1mselect-cursor-start()
	     [0mThis action is similar to [1mselect-start [0mexcept that
	     it begins the selection at the current text cursor
	     position.

     [1mselect-cursor-end([0m_d_e_s_t_n_a_m_e [1m[, ...])
	     [0mThis action is similar to [1mselect-end [0mexcept that it
	     should be used with [1mselect-cursor-start[0m.

     [1mset-vt-font([0m_d/_1/_2/_3/_4/_e/_s [1m[,[0m_n_o_r_m_a_l_f_o_n_t [1m[, [0m_b_o_l_d_f_o_n_t[1m]])
	     [0mThis action sets the font or fonts currently being
	     used in the VT102 window.	The first argument is a
	     single character that specifies the font to be used:
	     _d or _D indicate the default font (the font initially
	     used when _x_t_e_r_m was started), _1 through _4 indicate
	     the fonts specified by the _f_o_n_t_1 through _f_o_n_t_4
	     resources, _e or _E indicate the normal and bold fonts
	     that may be set through escape codes (or specified
	     as the second and third action arguments, respec-
	     tively), and _i or _I indicate the font selection (as
	     made by programs such as _x_f_o_n_t_s_e_l(_1)) indicated by
	     the second action argument.

     [1mstart-extend()
	     [0mThis action is similar to [1mselect-start except that
	     the selection is extended to the current pointer
	     location.

     start-cursor-extend()
	     [0mThis action is similar to [1mselect-extend [0mexcept that
	     the selection is extended to the current text cursor
	     position.

     [1mstring([0m_s_t_r_i_n_g[1m)
	     [0mThis action inserts the specified text string as if
	     it had been typed.  Quotation is necessary if the
	     string contains whitespace or non-alphanumeric char-
	     acters.  If the string argument begins with the
	     characters ``0x'', it is interpreted as a hex char-
	     acter constant.

     [1mscroll-back([0m_c_o_u_n_t [1m[,[0m_u_n_i_t_s[1m])
	     [0mThis action scrolls the text window backward so that
	     text that had previously scrolled off the top of the
	     screen is now visible.  The _c_o_u_n_t argument indicates



Printed 31/1/92             Release 4			       24






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



	     the number of _u_n_i_t_s (which may be _p_a_g_e, _h_a_l_f_p_a_g_e,
	     _p_i_x_e_l, or _l_i_n_e) by which to scroll.

     [1mscroll-forw([0m_c_o_u_n_t [1m[,[0m_u_n_i_t_s[1m])
	     [0mThis action scrolls is similar to [1mscroll-back [0mexcept
	     that it scrolls the other direction.

     [1mallow-send-events([0m_o_n/_o_f_f/_t_o_g_g_l_e[1m)
	     [0mThis action set or toggles the [1mallowSendEvents
	     [0mresource and is also invoked by the [1mallowsends [0mentry
	     in _m_a_i_n_M_e_n_u.

     [1mset-logging([0m_o_n/_o_f_f/_t_o_g_g_l_e[1m)
	     [0mThis action toggles the [1mlogging [0mresource and is also
	     invoked by the [1mlogging [0mentry in _m_a_i_n_M_e_n_u.

     [1mredraw()
	     [0mThis action redraws the window and is also invoked
	     by the _r_e_d_r_a_w entry in _m_a_i_n_M_e_n_u.

     [1msend-signal([0m_s_i_g_n_a_m_e[1m)
	     [0mThis action sends the signal named by _s_i_g_n_a_m_e (which
	     may also be a number) to the _x_t_e_r_m subprocess (the
	     shell or program specified with the -_e command line
	     option) and is also invoked by the [1msuspend[0m, [1mcon-
	     tinue[0m, [1minterrupt[0m, [1mhangup[0m, [1mterminate[0m, and _k_i_l_l
	     entries in _m_a_i_n_M_e_n_u.  Allowable signal names are
	     (case is not significant): _s_u_s_p_e_n_d, _t_s_t_p (if sup-
	     ported by the operating system), _c_o_n_t (if supported
	     by the operating system), _i_n_t, _h_u_p, _t_e_r_m, and _k_i_l_l.

     [1mquit()  [0mThis action sends a SIGHUP to the subprogram and
	     exits.  It is also invoked by the [1mquit [0mentry in
	     _m_a_i_n_M_e_n_u.

     [1mset-scrollbar([0m_o_n/_o_f_f/_t_o_g_g_l_e[1m)
	     [0mThis action toggles the [1mscrollbar [0mresource and is
	     also invoked by the [1mscrollbar [0mentry in _v_t_M_e_n_u.

     [1mset-jumpscroll([0m_o_n/_o_f_f/_t_o_g_g_l_e[1m)
	     [0mThis action toggles the [1mjumpscroll [0mresource and is
	     also invoked by the [1mjumpscroll [0mentry in _v_t_M_e_n_u.

     [1mset-reverse-video([0m_o_n/_o_f_f/_t_o_g_g_l_e[1m)
	     [0mThis action toggles the _r_e_v_e_r_s_e_V_i_d_e_o resource and is
	     also invoked by the [1mreversevideo [0mentry in _v_t_M_e_n_u.

     [1mset-autowrap([0m_o_n/_o_f_f/_t_o_g_g_l_e[1m)
	     [0mThis action toggles automatic wrapping of long lines
	     and is also invoked by the [1mautowrap [0mentry in _v_t_M_e_n_u.

     [1mset-reversewrap([0m_o_n/_o_f_f/_t_o_g_g_l_e[1m)



[0mPrinted 31/1/92             Release 4			       25






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



	     This action toggles the [1mreverseWrap [0mresource and is
	     also invoked by the [1mreversewrap [0mentry in _v_t_M_e_n_u.

     [1mset-autolinefeed([0m_o_n/_o_f_f/_t_o_g_g_l_e[1m)
	     [0mThis action toggles automatic insertion of linefeeds
	     and is also invoked by the [1mautolinefeed [0mentry in
	     _v_t_M_e_n_u.

     [1mset-appcursor([0m_o_n/_o_f_f/_t_o_g_g_l_e[1m)
	     [0mThis action toggles the handling Application Cursor
	     Key mode and is also invoked by the Bappcursor entry
	     in _v_t_M_e_n_u.

     [1mset-appkeypad([0m_o_n/_o_f_f/_t_o_g_g_l_e[1m)
	     [0mThis action toggles the handling of Application
	     Keypad mode and is also invoked by the [1mappkeypad
	     [0mentry in _v_t_M_e_n_u.

     [1mset-scroll-on-key([0m_o_n/_o_f_f/_t_o_g_g_l_e[1m)
	     [0mThis action toggles the [1mscrollKey [0mresource and is
	     also invoked from the [1mscrollkey [0mentry in _v_t_M_e_n_u.

     [1mset-scroll-on-tty-output([0m_o_n/_o_f_f/_t_o_g_g_l_e[1m)
	     [0mThis action toggles the [1mscrollTtyOutput [0mresource and
	     is also invoked from the [1mscrollttyoutput [0mentry in
	     _v_t_M_e_n_u.

     [1mset-allow132([0m_o_n/_o_f_f/_t_o_g_g_l_e[1m)
	     [0mThis action toggles the [1mc132 [0mresource and is also
	     invoked from the [1mallow132 [0mentry in _v_t_M_e_n_u.

     [1mset-cursesemul([0m_o_n/_o_f_f/_t_o_g_g_l_e[1m)
	     [0mThis action toggles the [1mcurses [0mresource and is also
	     invoked from the [1mcursesemul [0mentry in _v_t_M_e_n_u.

     [1mset-visual-bell([0m_o_n/_o_f_f/_t_o_g_g_l_e[1m)
	     [0mThis action toggles the [1mvisualBell [0mresource and is
	     also invoked by the [1mvisualbell [0mentry in _v_t_M_e_n_u.

     [1mset-marginbell([0m_o_n/_o_f_f/_t_o_g_g_l_e[1m)
	     [0mThis action toggles the [1mmarginBell [0mresource and is
	     also invoked from the [1mmarginbell [0mentry in _v_t_M_e_n_u.

     [1mset-altscreen([0m_o_n/_o_f_f/_t_o_g_g_l_e[1m)
	     [0mThis action toggles between the alternative and
	     current screens.

     [1msoft-reset()
	     [0mThis action resets the scrolling region and is also
	     invoked from the [1msoftreset [0mentry in _v_t_M_e_n_u.

     [1mhard-reset()



[0mPrinted 31/1/92             Release 4			       26






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



	     This action resets the scrolling region, tabs, win-
	     dow size, and cursor keys and clears the screen.  It
	     is also invoked from the [1mhardreset [0mentry in _v_t_M_e_n_u.

     [1mset-terminal-type([0m_t_y_p_e[1m)
	     [0mThis action directs output to either the _v_t or _t_e_k
	     windows, according to the _t_y_p_e string.  It is also
	     invoked by the [1mtekmode [0mentry in _v_t_M_e_n_u and the
	     [1mvtmode [0mentry in _t_e_k_M_e_n_u.

     [1mset-visibility([0m_v_t/_t_e_k[1m,[0m_o_n/_o_f_f/_t_o_g_g_l_e[1m)
	     [0mThis action controls whether or not the _v_t or _t_e_k
	     windows are visible.  It is also invoked from the
	     [1mtekshow [0mand [1mvthide [0mentries in _v_t_M_e_n_u and the [1mvtshow
	     [0mand [1mtekhide [0mentries in _t_e_k_M_e_n_u.

     [1mset-tek-text([0m_l_a_r_g_e/_2/_3/_s_m_a_l_l[1m)
	     [0mThis action sets font used in the Tektronix window
	     to the value of the resources [1mtektextlarge[0m, [1mtek-
	     text2[0m, [1mtektext3[0m, and [1mtektextsmall [0maccording to the
	     argument.	It is also by the entries of the same
	     names as the resources in _t_e_k_M_e_n_u.

     [1mtek-page()
	     [0mThis action clears the Tektronix window and is also
	     invoked by the [1mtekpage [0mentry in _t_e_k_M_e_n_u.

     [1mtek-reset()
	     [0mThis action resets the Tektronix window and is also
	     invoked by the _t_e_k_r_e_s_e_t entry in _t_e_k_M_e_n_u.

     [1mtek-copy()
	     [0mThis action copies the escape codes used to generate
	     the current window contents to a file in the current
	     directory beginning with the name COPY.  It is also
	     invoked from the _t_e_k_c_o_p_y entry in _t_e_k_M_e_n_u.

     The Tektronix window also has the following action:

     [1mgin-press([0m_l/_L/_m/_M/_r/_R[1m)
	     [0mThis action send the indicated graphics input code.

     The default bindings in the VT102 window are:


	   Shift <KeyPress> Prior: scroll-back(1,halfpage) \n\
	    Shift <KeyPress> Next: scroll-forw(1,halfpage) \n\
	  Shift <KeyPress> Select: select-cursor-start() \
				   select-cursor-end(PRIMARY, CUT_BUFFER0) \n\
	  Shift <KeyPress> Insert: insert-selection(PRIMARY, CUT_BUFFER0) \n\
		  ~Meta<KeyPress>: insert-seven-bit() \n\
		   Meta<KeyPress>: insert-eight-bit() \n\



Printed 31/1/92             Release 4			       27






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



	     Ctrl ~Meta<Btn1Down>: popup-menu(mainMenu) \n\
		 ~Meta <Btn1Down>: select-start() \n\
	       ~Meta <Btn1Motion>: select-extend() \n\
	    Ctrl ~Meta <Btn2Down>: popup-menu(vtMenu) \n\
	   ~Ctrl ~Meta <Btn2Down>: ignore() \n\
	     ~Ctrl ~Meta <Btn2Up>: insert-selection(PRIMARY, CUT_BUFFER0) \n\
	    Ctrl ~Meta <Btn3Down>: popup-menu(fontMenu) \n\
	   ~Ctrl ~Meta <Btn3Down>: start-extend() \n\
	       ~Meta <Btn3Motion>: select-extend() \n\
	      ~Ctrl ~Meta <BtnUp>: select-end(PRIMARY, CUT_BUFFER0) \n\
			<BtnDown>: bell(0)


     The default bindings in the Tektronix window are:


		~Meta<KeyPress>:   insert-seven-bit() \n\
		 Meta<KeyPress>:   insert-eight-bit()\n\
	   Ctrl ~Meta<Btn1Down>:   popup-menu(mainMenu) \n\
	  Ctrl ~Meta <Btn2Down>:   popup-menu(tekMenu) \n\
	  Shift ~Meta<Btn1Down>:   gin-press(L) \n\
		~Meta<Btn1Down>:   gin-press(l) \n\
	  Shift ~Meta<Btn2Down>:   gin-press(M) \n\
		~Meta<Btn2Down>:   gin-press(m) \n\
	  Shift ~Meta<Btn3Down>:   gin-press(R) \n\
		~Meta<Btn3Down>:   gin-press(r)


     Below is a sample how of the [1mkeymap() [0maction is used to add
     special keys for entering commonly-typed works:


	  *VT100.Translations: #override <Key>F13: keymap(dbx)
	  *VT100.dbxKeymap.translations: \
	       <Key>F14: keymap(None) \n\
	       <Key>F17: string("next") string(0x0d) \n\
	       <Key>F18: string("step") string(0x0d) \n\
	       <Key>F19: string("continue") string(0x0d) \n\
	       <Key>F20: string("print ") insert-selection(PRIMARY, CUT_BUFFER0)


[1mOTHER FEATURES
     [0m_X_t_e_r_m automatically highlights the window border and text
     cursor when the pointer enters the window (selected) and
     unhighlights them when the pointer leaves the window
     (unselected).  If the window is the focus window, then the
     window is highlighted no matter where the pointer is.

     In VT102 mode, there are escape sequences to activate and
     deactivate an alternate screen buffer, which is the same
     size as the display area of the window.  When activated, the
     current screen is saved and replace with the alternate



Printed 31/1/92             Release 4			       28






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



     screen.  Saving of lines scrolled off the top of the window
     is disabled until the normal screen is restored.  The
     _t_e_r_m_c_a_p(5) entry for _x_t_e_r_m allows the visual editor _v_i(1) to
     switch to the alternate screen for editing, and restore the
     screen on exit.

     In either VT102 or Tektronix mode, there are escape
     sequences to change the name of the windows and to specify a
     new log file name.

[1mENVIRONMENT
     [0m_X_t_e_r_m sets the environment variables ``TERM'' and
     ``TERMCAP'' properly for the size window you have created.
     It also uses and sets the environment variable ``DISPLAY''
     to specify which bit map display terminal to use.	The
     environment variable ``WINDOWID'' is set to the X window id
     number of the _x_t_e_r_m window.

[1mSEE ALSO
     [0mresize(1), X(1), pty(4), tty(4)
     _X_t_e_r_m _C_o_n_t_r_o_l _S_e_q_u_e_n_c_e_s

[1mBUGS
     [0mThe _X_t_e_r_m _C_o_n_t_r_o_l _S_e_q_u_e_n_c_e_s document has yet to be converted
     from X10.	The old version, along with a first stab at an
     update, are available in the sources.

     The class name is _X_T_e_r_m instead of _X_t_e_r_m.

     [1mXterm will hang forever if you try to paste too much text at
     one time.	[0mIt is both producer and consumer for the pty and
     can deadlock.

     Variable-width fonts are not handled.

     This program still needs to be rewritten.	It should be
     split into very modular sections, with the various emulators
     being completely separate widgets that don't know about each
     other.  Ideally, you'd like to be able to pick and choose
     emulator widgets and stick them into a single control
     widget.

     The focus is considered lost if some other client (e.g., the
     window manager) grabs the pointer; it is difficult to do
     better without an addition to the protocol.

     There needs to be a dialog box to allow entry of log file
     name and the COPY file name.

     Many of the options are not resettable after _x_t_e_r_m starts.





Printed 31/1/92             Release 4			       29






XTERM(1)	    UNIX Programmer's Manual		 XTERM(1)



     The Tek widget does not support key/button re-binding.

[1mCOPYRIGHT
     [0mCopyright 1989, Massachusetts Institute of Technology.
     See _X(_1) for a full statement of rights and permissions.

[1mAUTHORS
     [0mFar too many people, including:

     Loretta Guarino Reid (DEC-UEG-WSL), Joel McCormack (DEC-
     UEG-WSL), Terry Weissman (DEC-UEG-WSL), Edward Moy (Berke-
     ley), Ralph R. Swick (MIT-Athena), Mark Vandevoorde (MIT-
     Athena), Bob McNamara (DEC-MAD), Jim Gettys (MIT-Athena),
     Bob Scheifler (MIT X Consortium), Doug Mink (SAO), Steve
     Pitschke (Stellar), Ron Newman (MIT-Athena), Jim Fulton (MIT
     X Consortium), Dave Serisky (HP)







































Printed 31/1/92             Release 4			       30



[0m